/* -*- mode: c++; c-basic-offset: 3; -*- */
#include "woutput.hh"

#include <sstream>

using namespace wpipe;
using namespace std;

//======================================  Output type constructor
wouttype::wouttype(void) {
}

//======================================  Output type constructor
wouttype::wouttype(const str_vect& channels, const std::string& time, 
		   const std::string& dir, const std::string& fmt, 
		   const std::string& type)
  : channelNames(channels)
{
  size_t N = channels.size();
  _paths.resize(N);
  for (size_t i=0; i<N; i++) {
    ostringstream oss;
    oss << dir  << "/" << channels[i].substr(0, 2) << "-OMEGA_TRIGGERS_"
	<< type << "-" << time << "." << fmt;
    _paths[i] = oss.str();
  }
}

//======================================  Find channel number
size_t 
wouttype::find(const std::string& chan) const {
  size_t N = channelNames.size();
  for (size_t i=0; i<N; i++) {
    if (chan == channelNames[i]) return i;
  }
  return N;
}

//======================================  wOutput constructor
woutput::woutput(const str_vect& channels, const std::string& time, 
		 const std::string& dir, const std::string& fmt, 
		 const str_vect& otyp) {
  str_vect types(otyp);
  if (types.empty()) {
    types.push_back("DOWNSELECT");
    types.push_back("CLUSTER");
    types.push_back("COINCIDE");
  }
  size_t N=types.size();
  //out_map.resize(N);
  for (size_t i=0; i<N; i++) {
    string type = types[i];
    out_map.insert(omap_value(type, wouttype(channels, time, dir, fmt, type)));
  }
}
